/******************************************************************************
*
* project name:  TICT Game Construction Kit (TICT-GCK)
* file name:     fileselection.c
* initial date:  29/06/2001
* author:        thomas.nussbaumer@gmx.net
*
* $Id$
*
******************************************************************************/
#include "gcklib.h"
#include <compat.h>
#include <menus.h>
#include <graph.h>
#include <string.h>
#include <vat.h>
#include <alloc.h>

//#include <tigcclib.h>

short __CheckSymbol(SYM_ENTRY* symptr,short(*callback)(unsigned char*)) {
    HANDLE         tmphandle;
    short          was_locked;
    short          cb_result;
    unsigned char* src;

    if (symptr->flags.bits.hidden ||
        symptr->flags.bits.twin   ||
        symptr->flags.bits.folder)
    {
        return 0;
    }

    tmphandle = symptr->handle;
    was_locked = HeapGetLock(tmphandle);

    if (was_locked) src = HeapDeref(tmphandle);
    else            src = HLock(tmphandle);

    if (!src) return 0;

    cb_result = callback(src);

    if (!was_locked) HeapUnlock(tmphandle);

    return cb_result;
}

//=============================================================================
// fileselection dialog
//
// credits for this routine goes to Zeljko Juric !!
// (I have adapted this code from his ScottFree driver)
//
//=============================================================================

SYM_ENTRY* FileSelection(char* dialogtitle,short(*callback)(unsigned char*),short *found) {
    short          select  = 0;
    short          index   = 1;
    short          handle  = PopupNew(dialogtitle,C89_92(53,69));
    SYM_ENTRY*     symptr;
    unsigned char  current[9];
    unsigned char  tiosname[12];
    unsigned char* current_folder;

    *found = 0;

    FolderGetCur(current);
    current_folder = GenerateTIOSName(current,tiosname);
    symptr = SymFindFirst(current_folder,1);

    FolderOp($(\x7F), FOP_LOCK);
    while (symptr) {
        if (__CheckSymbol(symptr,callback)) {
            char desc[9];
            memset(desc,0,9);
            strncpy(desc,symptr->name,8);
            (*found)++;
            PopupAddText(handle,-1,desc,index);
            index++;
        }
        symptr=SymFindNext();
    }
    FolderOp($(\x7F), FOP_UNLOCK);

    if (*found) select = PopupDo(handle,CENTER,CENTER,0);
    HeapFree(handle);

    if (!select) return 0;

    FolderOp($(\x7F), FOP_LOCK);
    symptr=SymFindFirst(current_folder,1);
    index = 0;
    do {
        if (!symptr) return 0;
        if (__CheckSymbol(symptr,callback)) {
            index++;
            if (index == select) break;
        }
        symptr=SymFindNext();
    }
    while(1);
    FolderOp($(\x7F), FOP_UNLOCK);
    return symptr;
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log$
//
