/******************************************************************************
*
* project name:  TICT Game Construction Kit (TICT-GCK)
* file name:     map.c
* initial date:  27/06/2001
* author:        thomas.nussbaumer@gmx.net
*
* $Id$
*
******************************************************************************/

#include "gcklib.h"

static unsigned short emptytile[32] = {
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
    0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000
};


short SetMapPosX(short x) {
    if (x<0)                      __map_pos_x__ = 0;
    else if (x<__map_pos_x_max__) __map_pos_x__ = x;
    else                          __map_pos_x__ = __map_pos_x_max__;
    return __map_pos_x__;
}

short SetMapPosY(short y) {
    if (y<0)                      __map_pos_y__ = 0;
    else if (y<__map_pos_y_max__) __map_pos_y__ = y;
    else                          __map_pos_y__ = __map_pos_y_max__;
    return __map_pos_y__;
}

//=============================================================================
// sets the used map
//=============================================================================
void SetMap(MAPDATA* mapdata,TILEDATA* tiledata,short pos_x,short pos_y) {
    __map_pointer__   = mapdata->data;
    __tiles_pointer__ = tiledata->data;
    __map_size_x__    = mapdata->size_x;
    __map_size_y__    = mapdata->size_y;
    __map_pos_x_max__ = (__map_size_x__<<4)-160;
    __map_pos_y_max__ = (__map_size_y__<<4)-100;
    SetMapPosX(pos_x);
    SetMapPosY(pos_y);
}

void DrawMap(void) {
    short xshift = __map_pos_x__%16;
    short xstart = __map_pos_x__>>4;
    short yshift = __map_pos_y__%16;
    short ystart = __map_pos_y__>>4;
    register short x;
    register short y;

    for (y=0;y<9;y++) for (x=0;x<12;x++) {
        unsigned short* tileptr;
        register short tmpx = xstart+x;
        register short tmpy = ystart+y;

        if (tmpx<0 || tmpx>=__map_size_x__ || tmpy<0 || tmpy>=__map_size_y__) {
            tileptr = emptytile;
        }
        else {
            tileptr = __tiles_pointer__ + ((*(__map_pointer__+tmpy*__map_size_x__+tmpx)<<5) & MASK_TILENR);
        }

        PutTile16x16Clipped((x<<4)-xshift,(y<<4)-yshift,tileptr);
    }
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log$
//
