/******************************************************************************
*
* project name:  TICT Game Construction Kit (TICT-GCK)
* file name:     putsprite16x16.c
* initial date:  27/06/2001
* author:        thomas.nussbaumer@gmx.net
*
* $Id$
*
******************************************************************************/

#include "gcklib.h"

//=============================================================================
// sprite drawing function for 16x16 pixel sized sprites
//
// (using an unrolled loop for speedup)
//
// NOTE: for performance reasons the sprite data looks like this:
//
// data for LIGHT_PLANE (16 unsigned short's)
// data for DARK_PLANE  (16 unsigned short's)
// data used as mask    (16 unsigned short's - but inverted!!)
//
// !! only 1 pointer is used to hand over the parameter !!
//
// NOTE2: This function operates on a LCD_SIZE*2 large backbuffer which is
//        given by the external variable backbuffer
//=============================================================================
void PutSprite16x16(short x,short y,unsigned short* spritedata) {
    register long            addr1   = (y<<5)-(y<<1)+((x>>3)&0xfffe)+(long)__backbuffer1__;
    register long            addr2   = addr1+3840;
    register unsigned short* sprite1 = spritedata;
    register unsigned short* sprite2 = sprite1+16;
    register unsigned short* mask    = sprite2+16;
    register unsigned short  cnt     = 16-(x&15);
    register long            val     = ~((long)(*mask++)<<cnt);

    //-------------------------------------------------------------------------
    // unrolled loop!
    //-------------------------------------------------------------------------
    // 1.
    *(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 2.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 3.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 4.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 5.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 6.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 7.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 8.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 9.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 10.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 11.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 12.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 13.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 14.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 15.
    val = ~((long)(*mask++)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 16.
    val = ~((long)(*mask)<<cnt);*(long*)addr1&=val,*(long*)addr2&=val;
    *(long*)addr1|=(long)(*sprite1)<<cnt,*(long*)addr2|=(long)(*sprite2)<<cnt;
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log$
//
