/******************************************************************************
*
* project name:  TICT Game Construction Kit (TICT-GCK)
* file name:     puttile16x16clipped.c
* initial date:  27/06/2001
* author:        thomas.nussbaumer@gmx.net
*
* $Id$
*
******************************************************************************/

#include "gcklib.h"

//=============================================================================
// tile drawing function for 16x16 pixel sized tile
//
// (using an unrolled loop for speedup)
//
// NOTE: for performance reasons the tile data looks like this:
//
// data for LIGHT_PLANE (16 unsigned short's)
// data for DARK_PLANE  (16 unsigned short's)
//
// !! only 1 pointer is used to hand over the parameter !!
//
// NOTE2: This function operates on a LCD_SIZE*2 large backbuffer which is
//        given by the external variable backbuffer
//=============================================================================
void PutTile16x16(short x,short y,unsigned short* tiledata) {
    register long            addr1   = (y<<5)-(y<<1)+((x>>3)&0xfffe)+(long)__backbuffer1__;
    register long            addr2   = addr1+3840;
    register unsigned short* sprite1 = tiledata;
    register unsigned short* sprite2 = sprite1+16;
    register unsigned short  cnt     = 16-(x&15);
    register unsigned long   mask    = ~(0x0000ffffL<<cnt);

    //-------------------------------------------------------------------------
    // unrolled loop!
    //-------------------------------------------------------------------------
    // 1.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 2.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 3.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 4.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 5.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 6.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 7.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 8.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 9.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 10.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 11.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 12.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 13.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 14.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 15.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1++)<<cnt,*(long*)addr2|=(long)(*sprite2++)<<cnt;
    addr1+=30,addr2+=30;
    // 16.
    *(long*)addr1&=mask,*(long*)addr2&=mask;
    *(long*)addr1|=(long)(*sprite1)<<cnt,*(long*)addr2|=(long)(*sprite2)<<cnt;
}


//#############################################################################
// Revision History
//#############################################################################
//
// $Log$
//
