/******************************************************************************
*
* project name:  TICT Game Construction Kit (TICTGCK)
* file name:     waitkeysreleased.c
* initial date:  27/06/2001
* author:        thomas.nussbaumer@gmx.net
*
* $Id$
*
******************************************************************************/

#include <intr.h>
#include <kbd.h>
#include "gcklib.h"

/*===========================================================================*/
/* waits until all keys are released                                         */
/*===========================================================================*/
void WaitForAllKeysReleased(void) {
    register short oldint1state = GetDefaultINT1Exec();
    register short oldint5state = GetDefaultINT5Exec();

    // disable calling of default INT1/INT5 handlers temporary
    SetDefaultINT1Exec(0);
    SetDefaultINT5Exec(0);

    while (_rowread(0) & 0xff);

    // restore previous values of default INT1/INT5 handlers execution
    SetDefaultINT1Exec(oldint1state);
    SetDefaultINT5Exec(oldint5state);
}

//#############################################################################
// Revision History
//#############################################################################
//
// $Log$
